#Mudflap's Custom Sky Tool, script for making custom skyboxes using your own rsh.




import tkFileDialog


import Tkinter

from Tkconstants import *
Hint = Tkinter.Tk()
frame = Tkinter.Frame(Hint, relief=RIDGE, borderwidth=2)
frame.pack(fill=BOTH,expand=1)
label = Tkinter.Label(frame, text="OPEN Hint \n For Best Results OPEN your rsh in the path: \n Dawn of War/modtools/datasrc/your_mod/Art/EBPS/Environment/Skies/name_of_your_sky/textures")
label2 = Tkinter.Label(frame, text="SAVE Hint \n For Best Results SAVE your whm in the path: \n Dawn of War/your_mod/Data/Art/EBPS/Environment/Skies")
label.pack(fill=X, expand=1)
label2.pack(fill=X, expand=1)
button = Tkinter.Button(frame,text="Close Hints",command=Hint.destroy)
button.pack(side=BOTTOM)

 

filetoparse = tkFileDialog.askopenfilename(filetypes=[("rsh", "rsh")], title = 'Choose a RSH File to Apply to Skybox')


 

filetowrite = tkFileDialog.asksaveasfilename(filetypes=[("whm", "whm")], title = 'Save New Skybox as.....', defaultextension = ".whm")

 

#filetoparse = 'test.rsh' #rsh wide sky file goes here.
#filetowrite = 'My_New_sky.whm'

writefile = open(filetowrite, 'wb')

g = open(filetoparse,'rb') 


#This part gets the chunks needed from the dummy_sky.whm.

skymodel = open('dummy_sky.whm','rb')

headerchunk = skymodel.read(144)        #This gets all the burninfo and sky header out of the way and get written at the front of the file

skymodel.seek(125)
skymodelreplace = skymodel.read(1)


skymodel.seek(349919)
skyshdrname = skymodel.read(17)

skymodel.seek(351079)

seekdifference = 354925 - 351079

meshchunk = skymodel.read(seekdifference)             #This gets written at the end

writefile.write(headerchunk)


#This part gets the data needed TXTR data from the rsh file

import struct
import binascii

g.read()
endoffile = g.tell() - 20
g.seek(40)
namelength = struct.unpack('<L', g.read(4))[0]
g.read(namelength)

txtrheader = g.read(20)
location = g.tell()
goback = location - 8
g.seek(goback)
chunksize = struct.unpack('<L', g.read(4))[0]
chunknamesize = struct.unpack('<L', g.read(4))[0]

txtrname = g.read(chunknamesize)
txtrchunk = g.read(chunksize)


writefile.write(txtrheader)
writefile.write(txtrname)
writefile.write(txtrchunk)


#This part gets the SHDR data needed from the rsh file 

shdrheader = g.read(16)
location = g.tell()
goback = location - 4
g.seek(goback)
chunksize = struct.unpack('<L', g.read(4))[0]
chunknamesize = struct.unpack('<L', g.read(4))[0]
shdrname = g.read(chunknamesize)

shdrchunk = g.read(chunksize)


writefile.write(shdrheader)
writefile.write(skyshdrname)
#   writefile.write(shdrname)
writefile.write(shdrchunk)


#then add the mesh chunk at the end.


writefile.write(meshchunk)


endoffileloc = writefile.tell()  # end of file should be 267549

filesize = endoffileloc - 144
intfilesize = int(filesize)


writefile.seek(125)
writefilelocation = writefile.tell()

import marshal
marshal.dump(intfilesize, writefile)

writefile.seek(125)
writefile.write(skymodelreplace)

print endoffileloc
print filesize
print writefilelocation

writefile.close()

Hint.mainloop()